/*
 *  PINT Pint Is Not TWAIN - common scanner driver interface for UN*X
 *  Copyright (C) 1994 Kenneth Stailey ken@spacenet.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* window size calculation for PINT
 * third release, version 0.3
 */

/* This is in a separate file because it requires the "long long" data type
 * (GNU C's 64-bit int) in order to prevent overflow or loss of precision.
 */

int window_size(int w, int xr, int l, int yr)
{
  unsigned long long wl, xrl, ll, yrl;

  wl  = (unsigned long long)w;
  xrl = (unsigned long long)xr;
  ll  = (unsigned long long)l;
  yrl = (unsigned long long)yr;

  return (int)(wl * xrl * ll * yrl / (long long)(1440000));
}

/* 1200*1200 = 1440000 */
