/*
 *  PINT Pint Is Not TWAIN - common scanner driver interface for UN*X
 *  Copyright (C) 1994 Kenneth Stailey ken@spacenet.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * fixup_fujitsu_grayscale.c: convert scanner output to PGM
 *
 * This is faster than using "pgminvert | pnmgamma" but does the same
 * thing basically.
 */

#include <stdio.h>
#include <math.h>

static int gamma_table[256];

void buildgamma(double gamma)
{
  int i, v;
  double one_over_gamma, index;

  one_over_gamma = 1.0 / gamma;

  for (i = 0; i <= 255; ++i) {
    index = (double)i / 255.0;
    v = (255.0 * pow(index, one_over_gamma)) + 0.5;
    if (v > 255)
      v = 255;
    gamma_table[i] = 255 - v;
  }
}

main()
{
  int ch;

  buildgamma(0.75);

  while ((ch = getchar()) != EOF)
    putchar((char)(gamma_table[ch]));
}
