/*
 *  PINT Pint Is Not TWAIN - common scanner driver interface for UN*X
 *  Copyright (C) 1994 Kenneth Stailey ken@spacenet.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * use_adf.c: make the scanner use the ADF as the next paper source
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/scanio.h>

void
usage(char *prog_name)
{
  fprintf(stderr, "usage: %s [-l <logical name>]\n", prog_name);
  exit(-1);
}

main(int argc, char *argv[])
{
  int sfd;
  char *logical_name = "scan0";
  char device[255];

  int c;
  extern int optind;
  extern char *optarg;

  extern int errno;

  while ((c = getopt(argc, argv, "l:")) != EOF) {
    switch (c) {
    case 'l':
      logical_name = optarg;
      break;

    case '?':
      usage(argv[0]);
      break;
    }
  }

  strcpy(device, "/dev/");
  strcat(device, logical_name);

  if ((sfd = open(device, O_RDONLY)) < 0) {
    fprintf(stderr, "open of %s failed: ", device);
    perror("");
    exit(errno);
  }

  if (ioctl(sfd, SCAN_USE_ADF, NULL) < 0) {
    perror("use_adf: ioctl SCAN_USE_ADF failed");
    fprintf(stderr, "use_adf: ADF probably empty or jammed\n");
    exit(errno);
  }

  close(sfd);
  exit(0);
}
